VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MSGrphFilter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes As Long)

Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalSize Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Private Declare Function GetObjectType Lib "gdi32" (ByVal hgdiobj As Long) As Long
Private Declare Function SetViewportExtEx Lib "gdi32" (ByVal hDC As Long, ByVal nX As Long, ByVal nY As Long, lpSize As Any) As Long
Private Declare Function CreateMetaFile Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String) As Long
Private Declare Function GetMetaFileBitsEx Lib "gdi32" (ByVal hMF As Long, ByVal nSize As Long, lpvData As Any) As Long
Private Declare Function SetMetaFileBitsEx Lib "gdi32" (ByVal nSize As Long, lpData As Any) As Long
Private Declare Function PlayMetaFile Lib "gdi32" (ByVal hDC As Long, ByVal hMF As Long) As Long
Private Declare Function CloseMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
Private Declare Function DeleteMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hDC As Long, ByVal nMapMode As Long) As Long

Private Const MM_ANISOTROPIC = 8
Private Const OBJ_METAFILE = 9
Private Const IBMFNSIZE = 256


'(* Data types defined by the Aldus Interface. *)

'typedef struct {
'   unsigned    slippery : 1;        /* TRUE if file may disappear. */
'   unsigned    write : 1;           /* TRUE if open for write. */
'   unsigned    unnamed : 1;         /* TRUE if unnamed. */
'   unsigned    linked : 1;          /* Linked to an FS FCB. */
'   unsigned    mark : 1;            /* Generic mark bit. */
'   FILETYPE    fType;               /* The file type. */
'#define IBMFNSIZE 124
'   short       handle;              /* MS-DOS open file handle. */
'   char        fullName[IBMFNSIZE]; /* Device, path, file names. */
'   DWORD       filePos;          /* Our current file posn. */
'} FILESPEC, FAR *LPFILESPEC;
'//Note: Although one-bit wide, the flags each occupy a full byte...


'Private Type ALDUS_FILESPEC_OLD
'   slippery As Byte                '/* TRUE if file may disappear. */
'   write As Byte                   '/* TRUE if open for write. */
'   unnamed As Byte                 '/* TRUE if unnamed. */
'   linked As Byte                  '/* Linked to an FS FCB. */
'   Mark As Byte                    '/* Generic mark bit. */
'   Flags As Integer
'   fType As Long                   '/* The file type. */
'   handle As Integer               '/* MS-DOS open file handle. */
'   fullName As String * IBMFNSIZE '/* Device, path, file names. */
'   fullName(IBMFNSIZE - 1) As Byte '/* Device, path, file names. */
'   filePos As Long                 '/* Our current file posn. */
'End Type

'Functions prototypes
'Public Declare Function ImportGr Lib "jpegim32.flt" (ByVal hIC As Integer, ByRef FileSpec As Any, ByRef PictInfo As Any, ByVal hMemPref As Long) As Long
'Public Declare Function ExportGr Lib "jpegim32.flt" (ByVal hIC As Long, ByRef FileSpec As Any, ByRef PictInfo As Any, ByVal hMemPref As Long) As Long
'Public Declare Function GetFilterInfo Lib "gifimp32.flt" (ByVal PageMakerVersion As Long, ByVal sIni As String, hPrefMem As Long, hFileTypes As Long) As Long
'Public Declare Function GetFilterPref Lib "gifimp32.flt" (ByVal hInst As Long, ByVal ahWnd As Long, ByVal hPrefMem As Long, ByVal wFlags As Long) As Long
'Public Declare Function SetFilterPref Lib "jpegim32.flt" (ByVal hMemPref As Long, ByVal szOption As String, ByVal szValue As String, ByVal dwReserved1 As Long, ByVal dwReserved2 As Long) As Long

Private Type ALDUS_FILESPEC
   flags As Long
   hFile As Long                   '/* The file handle. */
   fullName(IBMFNSIZE - 1) As Byte '/* Device, path, file names. */
   filePos As Long                 '/* Our current file posn. */
   Unknown As Long
End Type

'Flags
Const fSlippery = &H1    ' { file may disappear }
Const fWrite = &H2       ' { open for write }
Const fUnnamed = &H4     ' { unnamed }
Const fLinked = &H8      ' { linked to an FS FCB }
Const fMark = &H10       ' { Generic mark bit }

Const CommonFileTypes = &H170000

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type ALDUS_PICTINFO
   hMF As Long
   rec As RECT
   inch As Long
End Type

Dim m_ImportSupported As Boolean
Dim m_ExportSupported As Boolean
Dim m_TransparentBk As Boolean
Dim m_JPEGQuality As Integer
Dim m_ShowProgress As Boolean

Dim hMemPref As Long
Dim FCall As cFuncCall

Public Property Let ShowProgress(ByVal bShow As Boolean)
    m_ShowProgress = bShow
End Property

Public Property Get ShowProgress() As Boolean
    ShowProgress = m_ShowProgress
End Property

Public Property Let JPEGQuality(ByVal Quality As Integer)
    m_JPEGQuality = Quality
End Property

Public Property Get JPEGQuality() As Integer
    JPEGQuality = m_JPEGQuality
End Property

Public Property Let TransparentBackground(ByVal bTransparent As Boolean)
    m_TransparentBk = bTransparent
End Property

Public Property Get TransparentBackground() As Boolean
    TransparentBackground = m_TransparentBk
End Property

Public Property Get IsImportSupported() As Boolean
   IsImportSupported = m_ImportSupported
End Property

Public Property Get IsExportSupported() As Boolean
   IsExportSupported = m_ExportSupported
End Property

Private Sub ApplySettings(ByVal sExt As String)
   Dim pMem As Long, lTemp As Long, nSize As Long
   If hMemPref = 0 Then Exit Sub
' *******hMemPref settings for *.gif,*.jpeg,*.png********
' jpg occupies 32 bytes, while *.gif and *.png occupy 36 bytes
' Offset   Default_Value          Description
'   0           2               nPageMakerversion(1-4)
'   4           2               MetaFileType(1-EMW,2-WMF)
'                               EMF files(1) are supported by
'                               nPageMakerVersion > 2 only
'   6           1               ProgressDialog Template number
'  10           1               ShowProgressDialog (Boolean)
'..22      75(jpg), 0(gif,png)  JPEG Quality, or transparent background
'                               for gif/png
   pMem = GlobalLock(hMemPref)
   nSize = GlobalSize(hMemPref)
   If nSize = 0 Then Exit Sub
   CopyMemory ByVal pMem, 2, 4
   If nSize >= 4 Then CopyMemory ByVal pMem + 4, 2, 1
   lTemp = Abs(m_ShowProgress)
   If pMem >= 6 Then CopyMemory ByVal pMem + 6, lTemp, 4
   If pMem >= 10 Then CopyMemory ByVal pMem + 10, lTemp, 4
   If sExt = "jpg" Then
      lTemp = m_JPEGQuality
      If lTemp Then CopyMemory ByVal pMem + 22, lTemp, 2
   ElseIf (sExt = "gif") Or (sExt = "png") Then
      lTemp = Abs(m_TransparentBk)
      If nSize >= 22 Then CopyMemory ByVal pMem + 22, CInt(lTemp), 2
   End If
   GlobalUnlock hMemPref
End Sub

Private Function GetFilterSettings(ByVal sFilterPath As String) As Boolean
    Dim lpfnGetFilterInfo As Long
    Dim lpfnGetFilterPref As Long
    Dim ret As Long
    
    FCall.LibraryName = sFilterPath
    FCall.FunctionName = "GetFilterInfo"
    ret = FCall.CallFunction(2, 0, VarPtr(hMemPref), CommonFileTypes)
    If (ret > 5000) Then 'ret is supported nPageMaker version. Currently 9. Error values started from 5000.
       ClearUp
       Exit Function
    End If
    GetFilterSettings = True
    FCall.FunctionName = "GetFilterPref"
    If FCall.curLPFN = 0 Then Exit Function
    If hMemPref Then FCall.CallFunction 0, 0, hMemPref, CommonFileTypes
End Function

Public Function MsoLoadPicture(ByVal sFilename As String, pb As PictureBox) As Boolean
    Dim sExt As String, sFilterPath As String
    Dim ret As Long, hDummy As Long, i As Long
    Dim picWidth As Single, picHeight As Single
    Dim pMem As Long, hMem As Long
    Dim lpfnImportGr As Long
    Dim PictInfo As ALDUS_PICTINFO
    Dim FileSpec As ALDUS_FILESPEC
    Dim sPic As StdPicture
    sExt = GetExtension(sFilename)
    sFilterPath = GetFilter(sExt, True).Path
    If GetFilterSettings(sFilterPath) = False Then Exit Function
    
    FCall.LibraryName = sFilterPath
    FCall.FunctionName = "ImportGr"
    If FCall.curLPFN = 0 Then FCall.FunctionName = "ImportGR"
    If FCall.curLPFN = 0 Then
       ClearUp
       Exit Function
    End If
    
    CopyMemory FileSpec.fullName(0), ByVal sFilename, IBMFNSIZE
    If (sExt = "jpg") Or (sExt = "gif") Or (sExt = "png") Then ApplySettings sExt
    ret = FCall.CallFunction(pb.hDC, VarPtr(FileSpec), VarPtr(PictInfo), hMemPref)
    If PictInfo.hMF = 0 Then ClearUp
'EMS and WPG filters return hMem value instead of hWMF, ie they return memory pointer to metafile
'bits instead of Metafile handle. Check this and convert memory block to MetaFile if nessesary
    If GetObjectType(PictInfo.hMF) <> OBJ_METAFILE Then
       hMem = PictInfo.hMF
       pMem = GlobalLock(hMem)
       PictInfo.hMF = SetMetaFileBitsEx(GlobalSize(hMem), ByVal pMem)
       PictInfo.inch = PictInfo.inch * 96 / 72
       GlobalUnlock hMem
       GlobalFree hMem
    End If
    If PictInfo.hMF = 0 Then ClearUp
'    picWidth = (PictInfo.rec.Right - PictInfo.rec.Left) / PictInfo.inch  'image width in inches
'    picHeight = (PictInfo.rec.Bottom - PictInfo.rec.Top) / PictInfo.inch 'image height in inches
    picWidth = PictInfo.rec.Right / PictInfo.inch  'image width in inches
    picHeight = PictInfo.rec.Bottom / PictInfo.inch 'image height in inches
    'convert inches to pixels
    picWidth = pb.ScaleX(picWidth, vbInches, vbPixels)
    picHeight = pb.ScaleX(picHeight, vbInches, vbPixels)
    On Error Resume Next
'    pb.Move PictInfo.rec.Left / PictInfo.inch, PictInfo.rec.Top / PictInfo.inch, picWidth * Screen.TwipsPerPixelX, picHeight * Screen.TwipsPerPixelY
    pb.Move 0, 0, picWidth * Screen.TwipsPerPixelX, picHeight * Screen.TwipsPerPixelY
'EMF filter call SetViewportExtEx internally, so second call lead to error.
    SetMapMode pb.hDC, MM_ANISOTROPIC
    If sExt <> "emf" Then
       SetViewportExtEx pb.hDC, picWidth, picHeight, ByVal 0&
    End If
    Call PlayMetaFile(pb.hDC, PictInfo.hMF)
    pb.Refresh
    DeleteMetaFile PictInfo.hMF
End Function

Public Function MsoSavePicture(ByVal sFilename As String, pb As PictureBox) As Boolean
    Dim sExt As String, sFilterPath As String
    Dim ret As Long, hMetaDC As Long, hDummy As Long, i As Long
    Dim lpfnGetFilterInfo As Long
    Dim lpfnExportGr As Long
'Actually, ExportGr require forth parameter as ExportCallBack address
'but VB address of function doesn't work in this case because above
'function declared as _cdecl. Following trick allow bypass this
'restriction - we fill stack with dummy values.
    Dim Dummy1 As Long, Dummy2 As Long, Dummy3 As Long, Dummy4 As Long
    Dim PictInfo As ALDUS_PICTINFO
    Dim FileSpec As ALDUS_FILESPEC
    
    ReDim abFileSpec(LenB(FileSpec) - 1)
    
    sExt = GetExtension(sFilename)
    If sExt = "bmp" Then
       SavePicture pb.Picture, sFilename
       MsoSavePicture = True
       Exit Function
    End If
    sFilterPath = GetFilter(sExt, False).Path
    FCall.LibraryName = sFilterPath
    If FCall.m_hLib = 0 Then Exit Function
    Call GetFilterSettings(sFilterPath)
    FCall.FunctionName = "ExportGr"
    If FCall.curLPFN = 0 Then FCall.FunctionName = "ExportGR"
    If FCall.curLPFN = 0 Then
       ClearUp
       Exit Function
    End If
'Transform picture(BMP) to WMF format
    hMetaDC = CreateMetaFile(vbNullString)
    Call BitBlt(hMetaDC, 0, 0, 0, 0, pb.hDC, 0, 0, vbSrcCopy)
    PictInfo.hMF = CloseMetaFile(hMetaDC)
'Apply some settings(Show_Progress, JPEG_Quality)
    If (sExt = "jpg") Or (sExt = "gif") Or (sExt = "png") Then ApplySettings sExt
    CopyMemory FileSpec.fullName(0), ByVal sFilename, IBMFNSIZE
'Fill up the stack with dummy values - see note above. Now callback function
'will just re-fill dummies
    Dummy1 = 1: Dummy2 = 1
    Dummy3 = 1: Dummy4 = 1
    ret = FCall.CallFunction(VarPtr(FileSpec), VarPtr(PictInfo), hMemPref)
    MsoSavePicture = (ret = 0)
    DeleteMetaFile PictInfo.hMF
    GlobalFree hMemPref
End Function

Private Sub Class_Initialize()
    Set FCall = New cFuncCall
    FCall.ShowError = False
    InitFilters
    m_JPEGQuality = Asc(GetRegValue(GetFilter("jpg", False).RegPath & "\Options", "Quality"))
    m_TransparentBk = (GetRegValue(GetFilter("gif", False).RegPath & "\Options", "SetMetafileBackgroundTransparent") = "Yes")
    m_ShowProgress = (GetRegValue(GetFilter("gif", False).RegPath & "\Options", "ShowProgressDialog") = "Yes")
End Sub

Private Sub Class_Terminate()
    ClearUp
    Set FCall = Nothing
End Sub

Private Sub InitFilters()
   Dim nBound As Long
   m_ImportSupported = EnumFilters(ImportFilters, eImport)
   m_ExportSupported = EnumFilters(ExportFilters, eExport)
End Sub

Private Function GetExtension(ByVal sFilename As String) As String
    Dim sExt As String
    sExt = Right(sFilename, 4)
    If Left(sExt, 1) = "." Then sExt = Mid(sExt, 2)
    If sExt = "tiff" Then sExt = "tif"
    If sExt = "jpeg" Then sExt = "jpg"
    GetExtension = LCase(sExt)
End Function

Private Function GetFilter(ByVal sExt As String, Optional bImport As Boolean = True) As FILTERINFO
    Dim i As Long
    If bImport Then
       For i = 0 To UBound(ImportFilters)
           If ImportFilters(i).Extension = sExt Then
              GetFilter = ImportFilters(i)
              Exit For
           End If
       Next i
    Else
       For i = 0 To UBound(ExportFilters)
           If ExportFilters(i).Extension = sExt Then
              GetFilter = ExportFilters(i)
              Exit For
           End If
       Next i
    End If
End Function

Private Sub ClearUp()
    GlobalFree hMemPref
    Set FCall = Nothing
End Sub
